*! by Hung-Jen Wang
*!    Department of Economics, National Taiwan University
*!    wangh@ntu.edu.tw

*! A mixture model of two normals.


*! Modifed from the previous version from the two-factor form of normalden() to the three-factor form. More stable.


capture program drop mixnormal
program define mixnormal

   version 12
   args lnf m1 m2 p1 s1 s2

   tempvar sigma1 sigma2 prob1

   quie gen double `sigma1'  = exp(`s1')
   quie gen double `sigma2' = exp(`s2')
   quie gen double `prob1' = exp(`p1')/(1+exp(`p1'))

   quie replace `lnf' = ln( `prob1'*normalden($ML_y1, `m1', `sigma1') + (1-`prob1')*normalden($ML_y2, `m2', `sigma2') )

end
